# use Docker to build the Docker image
image: docker:latest

services:
  - docker:dind

stages:
- build
- push


variables:
  CONTAINER_TAG_FOR_TESTS: deepcube/kratos-selfservice-ui-node:test-image
  CONTAINER_TEST_IMAGE: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
  CONTAINER_RELEASE_IMAGE: $CI_REGISTRY_IMAGE:latest
  CONTAINER_RELEASE_TAGGED_IMAGE: $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG

before_script:
  # login to private Docker registry
  - echo -n $CI_REGISTRY_PASSWORD | docker login -u "$CI_REGISTRY_USER" --password-stdin $CI_REGISTRY


# build the image and push it on gitlab registry
build:
  stage: build
  script:
    - docker build --pull -t "$CONTAINER_TEST_IMAGE" .
    - docker push "$CONTAINER_TEST_IMAGE"

# push "latest" image to the registry
build-latest:
  stage: push
  only:
    - main # latest from master only
  script:
    - docker pull $CONTAINER_TEST_IMAGE
    - docker tag $CONTAINER_TEST_IMAGE $CONTAINER_RELEASE_IMAGE
    - docker push $CONTAINER_RELEASE_IMAGE

# push "tagged" image to the registry
build-release:
  stage: push
  # only start a release on tags of master (not other branches)
  only:
    - tags # latest from master only
  except:
    - branches
  script:
    - docker pull $CONTAINER_TEST_IMAGE
    - docker tag $CONTAINER_TEST_IMAGE $CONTAINER_RELEASE_TAGGED_IMAGE
    - docker push $CONTAINER_RELEASE_TAGGED_IMAGE
